package com.example.listener;

import com.example.entity.QueueMessage;
import com.example.entity.dto.VerifyMailError;
import com.example.mapper.VerifyMailErrorMapper;
import com.example.utils.Const;
import jakarta.annotation.Resource;
import lombok.extern.slf4j.Slf4j;
import org.springframework.amqp.rabbit.annotation.RabbitHandler;
import org.springframework.amqp.rabbit.annotation.RabbitListener;
import org.springframework.stereotype.Component;

import java.util.Date;

@Slf4j
@Component
@RabbitListener(queues = Const.MQ_ERROR)
public class ErrorQueueListener {

    @Resource
    VerifyMailErrorMapper mapper;

    @RabbitHandler
    public void saveErrorToDatabase(QueueMessage message) {
        log.error("出现一条错误的队列消息: {}", message);
        switch (message.getMessageType()) {
            case "email" -> {
                VerifyMailError error = new VerifyMailError()
                        .setCode(message.get("code").toString())
                        .setType(message.get("type"))
                        .setEmail(message.get("email"))
                        .setTime(new Date());
                mapper.insert(error);
            }
        }
    }
}
